/* ST/compiler specific includes */
#if LATTICE
# include <osbind.h>
#elif __PUREC__
/* Pure-C & AHCC */
# include <tos.h>
# include <aes.h>
# include <vdi.h>
#elif __VBCC__
# include <tos.h>
# include <gem.h>
#elif __GNUC__
# include <osbind.h>
# include <gem.h>
#else
# error "Unknown compiler (not Lattice, Pure-C, AHCC, VBCC, GCC), aborting!"
#endif /* LATTICE|__PUREC__|__VBCC__|__GNUC__ */

/* a_* variables are pointers to AES structures which type is specified
 * differently between different compilers. Furthermore, Ballerburg assumes
 * that it can do char* arithmetics on them.  So, they're cast to obj_t when
 * they're given to functions that (may) expect pointers instead of integers.
 * 
 * Named typedef cast is used so that it's easier to find where this happens
 * in case this source is at some point cleaned out more.
 */
#if 1
typedef OBJECT* obj_t;
#else
typedef unsigned long obj_t;
#endif

#ifndef LATTICE
/* Lattice-C compatibility defines */
# define movmem(src,dst,count) memcpy((void*)(dst),(void*)(src),count)
# define setmem(dst,count,c) memset((void*)(dst),c,count)
#endif

/* common standard ANSI-C headers */
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* common Ballerburg defines */
#define Min(a,b)  ((a)<(b)?(a):(b))
#define Max(a,b)  ((a)>(b)?(a):(b))
#define maus()    graf_mkstate(&mx,&my,&bt,&dum)
#define menu(a)   wind_update(3-a)
#define hide()    graf_mouse(256,0)
#define show()    graf_mouse(257,0)
#define PI        3.1416
#define P57       57.296
#define G         0.02
#define bing()    (void)Cconws("\007")
#define fn()      fg=(1-2*(nk&1))

/* variables in baller1.c (used by baller2.c) */
typedef struct {
	short x,y,w,p;
} xywp_t;
extern xywp_t ka[2][10];
typedef struct {
	short x,y;
} xy_t;
extern xy_t ft[2][5];

extern double vvx,vvy;
extern short handle,mx,my,bt,dum,m_buf[8], xy[100],
      fx,fy,fw,fh,ftx,fty,ftw,fth;
extern short bur[2],bx[2],by[2], ge[2],pu[2],ku[2],vo[2],st[2],kn[2],
      wx[2], wy[2], ws, wc, *bg, zug, nk, p[6],
      f_h, *burgen[20], b_anz;
extern unsigned long a_sta;
extern signed char fg, mod, ended, wnd, mxin, au_kap, an_erl;
extern unsigned char cw[2], cx[2];

/* functions in baller1.c (used by baller2.c) */
extern void sav_scr(void);
extern void lod_scr(void);
extern void rst_scr(short x, short y, short w, short h);
extern void werdran(short c);
extern short color(short a);
extern int loc(short x, short y);
extern void line(short x1, short y1, short x2, short y2);
extern void clr(short x, short y, short w, short h);
extern void cls(void);

/* functions in baller2.c (used by baller1.c) */
extern int comp(void);
extern void schuss(short k);
extern void bild(void);
extern void drw_gpk(short w);
extern void markt(void);
extern void burg(short nn);
extern void koenig(void);
extern int drin(short xk,short yk,short w,short h,short r,short x,short y);

/* functions in musik.c (used by baller1.c) */
extern void m_musik(void);
extern void m_laden(const char *string);
