/*****************************************************************************
 *                           B a l l e r b u r g          Modul 1            *
 * Dies ist der Hauptteil von Ballerburg. Die Routinen dieses Teils dienen   *
 * im groen und ganzen der Steuerung des Programmes, dem Aufruf der Objekt- *
 * bume, sowie der Ausfhrung elementarer Grafikoperationen.                *
 *                                       29.4.87      Eckhard Kruse          *
 *                                                    Reichenbergweg 7       *
 *                                                    D-3302 Weddel          *
 * berarbeitet: 22.10.89                                                    *
 *****************************************************************************/
#include "baller.h"	/* common defines, variables and functions */
#include "resource.h"   /* RSC file object IDs */
#define BALLER1 1
#include "texts.h"

/* set to 1 to disable direct screen data access for debuggging purposes */
#define NO_DIRECT_ACCESS 0

int _mneed=20000; /* wichtig bei Lattice C, damit sich das Programm nicht */
 /* gleich den ganzen Speicherplatz schnappt, sondern nur 20K. */

/* exported variables */
xywp_t ka[2][10];
xy_t ft[2][5];
double vvx,vvy;
short handle,mx,my,bt,dum,m_buf[8], xy[100],
      fx,fy,fw,fh, ftx,fty,ftw,fth;
short bur[2],bx[2],by[2], ge[2],pu[2],ku[2],vo[2],st[2],kn[2],
      wx[2], wy[2], ws, wc, *bg, zug, nk, p[6],
      f_h, *burgen[20], b_anz;
unsigned long a_sta;
signed char fg, mod, ended, wnd, mxin, au_kap, an_erl;
unsigned char cw[2]={2,2}, cx[2]={1,1};

/* local variables */
static char txt[4],
	 cn[7][8]={ "Tlpel","Dummel","Brubbel",
      "Wusel","Brsel","Toffel","Rpel" },
      t_na[6][8]={ "Tlpel","Dummel","Brubbel","Wusel","Brsel","Toffel" },
      nsp1[22]="Hugo", nsp2[22]="Emil";
static char *l_nam, *r_nam;
static short t_gew[6][10], max_rund;
static unsigned long a_opt, a_ein,
      a_men, a_inf, a_sch, a_brg, a_nam, a_dra,
      a_sie, a_com, a_re1, a_re2, a_re3;
static unsigned long bur_ad, buf, scr, bufsize;
static short menuh, wd, ht, planes, win_handle;

/* local function prototypes */
static int event(void);
static void tabelle(void);
static void z_txt(short a);
static void neues(void);
static int ein_zug(void);
static void rechnen(void);
static void ende(void);
static void fahne(void);
static int t_load(void);
static int t_save(void);
static void burgen_laden(void);
static char zeichen(void);
static int rdzahl(void);
static int sch_obj(short k);
static int bur_obj(void);
static int obj_do(unsigned long adr);
static void gem_init(void);
static void gem_exit(void);
static void box(short x, short y,short x2, short y2);

/*****************************************************************************/
int main(int argc, char *argv[])
{
   short i;

   gem_init();

   m_laden("BALLER.MUS"); /* Laden der Musikdatei mit Funktion aus MUSIK.C */
   if( !rsrc_load( RSCFILE ) )
   {
      form_alert(1,DLG_RSC);
      gem_exit();
      exit( 1 );
   }

   rsrc_gaddr( 0,MENUE,&a_men  );  rsrc_gaddr( 0,INFOTREE,&a_inf );
   rsrc_gaddr( 0,SCHUSS,&a_sch );  rsrc_gaddr( 0,BURG,&a_brg );
   rsrc_gaddr( 0,NAMEN,&a_nam  );  rsrc_gaddr( 0,DRAN,&a_dra );
   rsrc_gaddr( 0,STATUS,&a_sta );  rsrc_gaddr( 0,SIEGER,&a_sie );
   rsrc_gaddr( 0,COMPUTER,&a_com); rsrc_gaddr( 0,REGEL1,&a_re1 );
   rsrc_gaddr( 0,REGEL2,&a_re2 );  rsrc_gaddr( 0,REGEL3,&a_re3 );
   rsrc_gaddr( 0,OPTION,&a_opt );  rsrc_gaddr( 0,EINTRAG,&a_ein );

   for( i=0;i<6;i++ ) *(short *)(a_men+(ACC1+i)*24+10)=8;
   *(short *)(a_com+CN1*24+58)=1;  *(short *)(a_com+CN2*24+58)=1;
   *(short *)(a_com+CTS1*24+34)=1; *(short *)(a_com+CTS2*24+34)=1;

   /* Speicher fr Burgdaten und zweiten Schirm holen */
   scr=(unsigned long)Logbase() + wd*menuh;
   bufsize=(unsigned long)wd*(ht-menuh);
   buf=(unsigned long)Malloc(bufsize + 10000);
   if( buf<1 ) exit( form_alert(1,DLG_MEM) );
   bur_ad=buf+bufsize;
   an_erl=1; mxin=3; max_rund=32767; au_kap=1; t_load(); burgen_laden();

   menu_bar((obj_t)a_men,1); menu(0);

   v_show_c( handle,0 ); graf_mouse( 0,0 );

   l_nam=nsp1; r_nam=nsp2; mod=0; neues();
   while( ein_zug() );

   t_save();
   menu_bar((obj_t)a_men,0); menu(1);
   gem_exit();
   return 0;
}

/* Verwaltung von Ereignissen: Messages, Maus oder Timer */ 
static int event(void)
{
   short wh;

#ifdef __GEMLIB__
   wh=evnt_multi( 50, 1,1,1, 0,0,0,0,0, 0,0,0,0,0,
               m_buf, 300UL, &mx,&my,&bt,&dum,&dum,&dum );
#else
   wh=evnt_multi( 50, 1,1,1, 0,0,0,0,0, 0,0,0,0,0,
               m_buf, 300,0, &mx,&my,&bt,&dum,&dum,&dum );
#endif
   if( wh&16 && m_buf[0]==10 )
   {
      menu(0);
      if( m_buf[4]==BINFO ) obj_do( a_inf );
      else if( m_buf[4]==SPI1 )     /* Neues Spiel */
      {
         if( bur_obj() ) { neues(); werdran(1); }
      }
      else if( m_buf[4]==SPI2 )     /* Namen eingeben */
      {
         movmem( nsp1, **(char ***)(a_nam+NSP1*24+12), 20 );
         movmem( nsp2, **(char ***)(a_nam+NSP2*24+12), 20 );
         if( obj_do( a_nam )==NOK )
         {
            movmem( **(char ***)(a_nam+NSP1*24+12), nsp1, 20 );
            movmem( **(char ***)(a_nam+NSP2*24+12), nsp2, 20 );
            if( !ended ) werdran(1);
         }
      }
      else if( m_buf[4]==SPI4 ) /* Optionen */
      {
         *(short*)(a_opt+A_ERL*24+10)=an_erl;
         *(short*)(a_opt+A_VER*24+10)=!an_erl;
         *(short*)(a_opt+MAX_1*24+10)=!mxin;
         *(short*)(a_opt+MAX_2*24+10)=(mxin==1);
         *(short*)(a_opt+MAX_XX*24+10)=(mxin==2);
         *(short*)(a_opt+MAX_NE*24+10)=(mxin==3);
         *(short*)(a_opt+A_KAP*24+10)=au_kap;
         if( obj_do(a_opt)==OP_OK )
         {
            char *h;
            au_kap=*(short*)(a_opt+A_KAP*24+10);
            an_erl=*(short*)(a_opt+A_ERL*24+10);
            mxin=*(short*)(a_opt+MAX_2*24+10)+
                 2**(short*)(a_opt+MAX_XX*24+10)+
                 3**(short*)(a_opt+MAX_NE*24+10);
            h=**(char ***)(a_opt+MAX_XX*24+12);
            max_rund=h[0]-48;
            if(h[1])
               { max_rund=max_rund*10+h[1]-48; if(h[2])
                 max_rund=max_rund*10+h[2]-48; }
            if(!mxin) max_rund=20; if(mxin==1) max_rund=50;
            if(mxin==3) max_rund=32767;
         }
      }
      else if( m_buf[4]==SPI3 ) return 1;      /* Quit? */
      else if( m_buf[4]>=MOD1 && m_buf[4]<=MOD4 )
      {                          /* Spielmodus ( wer gegen wen ) */
         menu_icheck( (obj_t)a_men,MOD1+mod,0 );
         mod=m_buf[4]-MOD1;
         menu_icheck( (obj_t)a_men,m_buf[4],1 );
      }
      else if( m_buf[4]==MOD5 )
      {                       /* Computer auswhlen */
         obj_do( a_com );
         for( cw[0]=0; cw[0]<7; cw[0]++ )
            if( *(short *)(a_com+24*(CN1+cw[0])+10) ) break;
         for( cw[1]=0; cw[1]<7; cw[1]++ )
            if( *(short *)(a_com+24*(CN2+cw[1])+10) ) break;
         for( cx[0]=0; cx[0]<4; cx[0]++ )
            if( *(short *)(a_com+24*(CTS1+cx[0])+10) ) break;
         for( cx[1]=0; cx[1]<4; cx[1]++ )
            if( *(short *)(a_com+24*(CTS2+cx[1])+10) ) break;
      }
      else if( m_buf[4]==REG )     /* Spielregeln */
      {
         short a=0,b;
         unsigned long c;

         sav_scr();
         form_center( (obj_t)a_re1,&fx,&fy,&fw,&fh );
         form_dial( 1,190,20,30,20,fx,fy,fw,fh );
         do
         {
	    c=a? (a<2? a_re2:a_re3):a_re1;
	    form_center( (obj_t)c,&fx,&fy,&fw,&fh );
            objc_draw( (obj_t)c, 0,5,fx,fy,fw,fh );
            b=form_do( (obj_t)c,0 ); *(short *)(c+24*b+10)=0;
            if( (a==1 && b==R21) || (a==2 && b==R31) ) { b=-1; a=0; }
            if( (a==0 && b==R12) || (a==2 && b==R32) ) { b=-1; a=1; }
            if( (a==0 && b==R13) || (a==1 && b==R23) ) { b=-1; a=2; }
         } while( b<0 );
         lod_scr();
         form_dial( 2,190,20,30,20,fx,fy,fw,fh );
      }
      else if( m_buf[4]==ERG1 )
      {
         movmem(t_na[0],**(char ***)(a_ein+EI_N1*24+12),8);
         movmem(t_na[1],**(char ***)(a_ein+EI_N2*24+12),8);
         movmem(t_na[2],**(char ***)(a_ein+EI_N3*24+12),8);
         movmem(t_na[3],**(char ***)(a_ein+EI_N4*24+12),8);
         movmem(t_na[4],**(char ***)(a_ein+EI_N5*24+12),8);
         movmem(t_na[5],**(char ***)(a_ein+EI_N6*24+12),8);
         *(short*)(a_ein+24*ER_LOE+10)=0; *(short*)(a_ein+24*ER_BLE+10)=1;
         if( obj_do( a_ein )==ER_OK )
         {
            short i,j;
            movmem(**(char ***)(a_ein+EI_N1*24+12),t_na[0],8);
            movmem(**(char ***)(a_ein+EI_N2*24+12),t_na[1],8);
            movmem(**(char ***)(a_ein+EI_N3*24+12),t_na[2],8);
            movmem(**(char ***)(a_ein+EI_N4*24+12),t_na[3],8);
            movmem(**(char ***)(a_ein+EI_N5*24+12),t_na[4],8);
            movmem(**(char ***)(a_ein+EI_N6*24+12),t_na[5],8);
            if(*(short*)(a_ein+24*ER_LOE+10))
               for(i=0;i<6;i++) for(j=0;j<10;j++) t_gew[i][j]=0;
         }
      }
      else if( m_buf[4]==ERG2 )
      {
         if( t_load() )
            form_alert(1,DLG_TAB );
      }
      else if( m_buf[4]==ERG3 ) t_save();
      else if( m_buf[4]==ERG4 )
      {
         sav_scr();
         form_dial( 1,260,20,30,20,48,52,548,308 );
         tabelle(); bt=0; while( !bt ) maus();
         lod_scr();
         form_dial( 2,260,20,30,20,48,52,548,308 );
      }
      if( m_buf[4]>=MOD1 && m_buf[4]<=MOD5 )
      {
         if( mod<2 ) l_nam=nsp1; else l_nam=cn[cw[0]];
         if( mod&1 ) r_nam=cn[cw[1]]; else r_nam=nsp2;
         if( !ended ) werdran(1);
      }
      menu_tnormal( (obj_t)a_men,m_buf[3],1 );
      menu(1);
   }
   return 0;
}

/************ screen save/load/part-restore ************/

#if NO_DIRECT_ACCESS
void sav_scr(void) { }
void lod_scr(void) { }
void rst_scr(short x, short y, short w, short h) {}
#else

void sav_scr(void)
{
   hide();
   movmem((void*)scr, (void*)buf, bufsize);
   show();
}

void lod_scr(void)
{
   hide();
   movmem((void*)buf, (void*)scr, bufsize);
   show();
}

void rst_scr(short x, short y, short w, short h)
{
   unsigned long start, end;
   int bytes, xx;

   if (y < menuh)
   {
      h -= menuh + y;
      y = menuh;
   }
   y -= menuh;

   xx = x*planes/8;
   start = (long)y*wd + xx;
   bytes = (x+w+7)*planes/8 - xx;
   if (bytes < 0 || bytes > wd)
      return;
   end = start + (long)h*wd + bytes;
   if (end > bufsize)
      end = bufsize;
   while (start < end)
   {
      movmem( buf+start, scr+start, bytes );
      start += wd;
   }
}

#endif /* !DEBUG */

/**************************** Tabelle ****************************************/
static void tabelle(void)
{
   short i,j,old;
   hide();
   old = color(1);
   vsf_interior(handle,0);
   box(53,56,587,343); box(55,58,585,341); box(56,59,584,340);
   line(144,59,144,340); for(i=152;i<584;i+=72) line(i,59,i,340);
   line(56,84,584,84); for(i=92;i<240;i+=24) line(56,i,584,i);
   for(i=244;i<340;i+=24) line(56,i,584,i);
   for(i=0;i<6;i++) v_gtext(handle,160+i*72,78,t_na[i]);
   for(i=0;i<6;i++) v_gtext(handle,80,110+i*24,t_na[i]);
   vsf_interior(handle,2); vsf_style(handle,2);
   for(i=0;i<6;i++) for(j=0;j<10;j++)
   {
      z_txt(t_gew[i][j]);
      if(j==9 && !t_gew[i][6] ) { txt[0]=32; txt[1]='-'; txt[2]=0; }
      v_gtext(handle,176+i*72,110+j*24+8*(j>5),txt);
      if(i==j) box(152+i*72,92+j*24,224+i*72,116+j*24);
   }
   v_gtext(handle,64,262,"\344" TXT_SPIELE);
   v_gtext(handle,64,286,"\344" TXT_GEWONNEN1);
   v_gtext(handle,64,310,"\344" TXT_VERLOREN1);
   v_gtext(handle,64,334,TXT_SIEGE);
   line(56,59,144,84); vst_height(handle,4,&i,&i,&i,&i);
   v_gtext(handle,60,81,TXT_VERLOREN2);
   v_gtext(handle,92,66,TXT_GEWONNEN2);
   vst_height(handle,13,&i,&i,&i,&i);
   color(old);
   show();
}

static void z_txt(short a)
{
   txt[0]=a/100+48; txt[1]=a%100/10+48; txt[2]=a%10+48;
   if(a<100) { txt[0]=32; if(a<10) txt[1]=32; }
   for(a=0;a<3;a++) txt[a]=txt[a]==48? 79: txt[a]==49? 108: txt[a];
}

/******************** Initialisierung vor neuem Spiel ************************/
static void neues(void)
{
   static short pr[6]={ 200,500,400,150,50,50 };   /* Preise zu Beginn */
   short i,j;

   wnd=Random()%60-30;
   st[0]=st[1]=20; kn[0]=kn[1]=0;
   for( j=0;j<6;j++ )
      p[j]=pr[j]*(95+Random()%11)/100;
   bild();
   for( i=0;i<2;i++ )
   {
      bg=burgen[bur[i]]; wx[i]=i? 639-bg[23]:bg[23]; wy[i]=by[i]-bg[24];
      for( j=0;j<5; ) ft[i][j++].x=-1;
   }
   zug=nk=ended=0; fg=1;
}

/************************* Durchfhren eines Zuges ***************************/
static int ein_zug(void)
{
   short i,fl,a;

   nk=zug&1; fn(); kn[nk]&=~16;
   wnd=wnd*9/10+Random()%12-6;

   werdran(1);

   do
   {
      fl=0;
      menu(1);
      do
      {
         if( event() ) return(0);
	 /* TODO: fix menu open check (inverted colors?) */
         for( a=i=0;i<60; i++) a|=*(char *)(scr+80+i);
      } while( (!bt && !(mod&(2-nk))) || a );
      menu(0);
      bg=burgen[bur[nk]];

      if( mod&(2-nk) ) { hide(); i=comp(); show(); fl=1+(i<0); }
      else if( mx>ftx && mx<ftx+ftw && my>fty && my<fty+fth ) fl=2;
      else
      {
         for( i=0;i<10;i++ )
         {
            if( ka[nk][i].x<=mx && ka[nk][i].x+20>=mx && ka[nk][i].x!=-1 &&
                ka[nk][i].y>=my && ka[nk][i].y-14<=my ) break;
         }
         if( i>9 )
         {
            if( drin( bg[25],bg[26],bg[31],bg[32],0,mx,my ) ||
                drin( bg[27],bg[28],bg[33],bg[34],0,mx,my ) ||
                drin( bg[29],bg[30],bg[35],bg[36],0,mx,my ) )
                    markt();
            else if( drin( bg[21],bg[22],30,25,0,mx,my ) )
		    koenig();
            else
		    bing();
         }
         else if( pu[nk]<5 )
          { bing(); form_alert(0,DLG_PULVER);}
         else if( !ku[nk] )
          { bing(); form_alert(0,DLG_KUGELN);}
         else fl=sch_obj(i);
      }
   } while( !fl );

   werdran(0);
   if( fl<2 ) schuss(i);

   if( ~kn[nk]&16 ) kn[nk]&=~15;
   rechnen(); zug++;

   for( i=0;i<10;i++ ) if( ka[nk][i].x>-1 ) break;
   nk=zug&1; bg=burgen[bur[nk]];
   for( a=0;a<10;a++ ) if( ka[nk][a].x>-1 ) break;
      if( a==10 && i<10 && bg[40]>vo[nk] && ge[nk]<p[2]/3 && au_kap && 
          ft[nk][0].x+ft[nk][1].x+ft[nk][2].x+ft[nk][3].x+ft[nk][4].x==-5 )
           ended=nk+33;

   if( !ended && zug/2 >= max_rund )
   {
      static int h[2];
      for(nk=0;nk<2;nk++)
      {
         h[nk]=ge[nk]+pu[nk]*p[4]/30+ku[nk]*p[5]/2+(wx[nk]>-1)*p[3]+vo[nk]*4;
         for(i=0;i<5;i++) if( ft[nk][i].x>-1 ) h[nk]+=p[1];
         for(i=0;i<10;i++) if( ka[nk][i].x>-1 ) h[nk]+=p[2];
      }
      ended=65+(h[1]<h[0]);
   }
   if( ended )
   {
      ende();
      menu(1);
      do
         if( event() ) return 0;
      while( !bt || ended );
      menu(0);
   }
   return 1;
}

/********** Berechnen von Bevlkerungszuwachs usw. nach jedem Zug ************/
static void rechnen(void)
{
   short j;
   static short pmi[6]={ 98,347,302,102,30,29 },   /* Preisgrenzen */
                pma[6]={ 302,707,498,200,89,91 },
                psp[6]={ 10,50,50,20,10,10 };     /* max. Preisschwankung */

   j=st[nk];
   ge[nk]+=vo[nk]*(j>65? 130-j:j)/(150-Random()%50);
   vo[nk]=vo[nk]*(95+Random()%11)/100+(21-j+Random()%9)*(8+Random()%5)/20;
   if( vo[nk]<0 ) { vo[nk]=0; ended=nk+49; }

   for( j=0;j<5;j++ ) ge[nk]+=(40+Random()%31)*(ft[nk][j].x>-1);
   for( j=0;j<6;j++ )
   {
      p[j]+=psp[j]*(Random()%99)/98-psp[j]/2;
      p[j]=Max(p[j],pmi[j]); p[j]=Min(p[j],pma[j]);
   }
   drw_gpk(0);
}

/******************************* Spielende ***********************************/
static void ende(void)
{
   int a,b,c;
   char s1[80],s2[80],s3[80], cc;
   void *sav_ssp;

   form_center( (obj_t)a_sie,&fx,&fy,&fw,&fh ); *(short *)(a_sie+18)=30;
   *(char **)(a_sie+24*SG1+12)=s1;
   *(char **)(a_sie+24*SG2+12)=s2;
   *(char **)(a_sie+24*SG3+12)=s3;
   strcpy( s1,"!! "); strcat( s1, ended&2? l_nam:r_nam );
   strcat( s1,TXT_GEWONNEN ); s2[0]=0;
   if(~ended&64) strcpy(s2,"( ");   strcat( s2, ended&2? r_nam:l_nam );
   if( (ended&240)<48 )
     { cc=s2[strlen(s2)-1]; strcat( s2, cc=='s' || cc=='S'? "' ":"s " ); }
   switch( ended&240 )
   {
      case 16: strcat( s2,TXT_GETROFFEN1 );
               strcpy( s3,TXT_GETROFFEN2 ); break;
      case 32: strcat( s2,TXT_KAPITULIERT1 );
               strcpy( s3,TXT_KAPITULIERT2 ); break;
      case 48: strcat( s2,TXT_KEIN_VOLK ); s3[0]=0; break;
      case 64: strcpy( s3,s2 );
               strcpy( s2,TXT_MAX_RUNDEN1);
               strcat( s3,TXT_MAX_RUNDEN2 );
   }
   /* this isn't centered, so clip to whole screen */
   objc_draw( (obj_t)a_sie,0,7,0,0,wd*8/planes,ht );

   for(a=0;a<6 && strncmp(t_na[a],l_nam,7);a++);
   for(b=0;b<6 && strncmp(t_na[b],r_nam,7);b++);
   if(a<6 && b<6 && a!=b)
   {
      if(~ended&2) { c=a; a=b; b=c; }
      t_gew[a][b]++; t_gew[b][8]++;
      t_gew[a][9]=100*++t_gew[a][7]/++t_gew[a][6];
      t_gew[b][9]=100*t_gew[b][7]/++t_gew[b][6];
   }
   hide(); sav_ssp=(void*)Super(0); m_musik(); Super(sav_ssp); show();  /* Musik... */
   (void)Giaccess( 0,138 ); (void)Giaccess( 0,139 ); (void)Giaccess( 0,140 );
}

/** Anzeige des Spielers, der am Zug ist, sowie Darstellung der Windfahnen ***/
void werdran(short c)
{
   short x,y,w,h;
   short *a,i,c1,s1,c2,s2;
   char *ad;
   double wk,wl;

   z_txt(zug/2+1); v_gtext(handle,332,395,txt);

   a=(short *)(a_dra+16);
   if( c )
   {
      a[0]=5+(629-a[2])*nk; a[1]=25;
      *(char **)(a_dra+DNAM*24+12)=nk? r_nam:l_nam;
      ad=*(char **)(a_dra+DWIN*24+12);
      ad[0]=ad[5]=4+28*!wnd-(wnd>0);
      i=wnd<0? -wnd:wnd;
      ad[2]=48+i/10; ad[3]=48+i%10;
      if( wx[nk]<0 ) { ad[0]=ad[5]=32; ad[2]=ad[3]='?'; }
      objc_offset( (obj_t)a_dra,DOK,&ftx,&fty );
      ftw=*(short *)(a_dra+DOK*24+20); fth=*(short *)(a_dra+DOK*24+22);
      objc_offset( (obj_t)a_dra,DWBX,&x,&y );
      w=*(short *)(a_dra+DWBX*24+20);  h=*(short *)(a_dra+DWBX*24+22);

      /* TODO: fix draw clipping? */
      objc_draw( (obj_t)a_dra,0,4,0,0,640,400 );

      c=wnd>0? 1:-1;  wk=c*wnd/15.0; wl=wk*.82;
      if( wk>1.57 ) wk=1.57;  if( wl>1.57 ) wl=1.57;
      s1=c*20*sin(wk); c1=20*cos(wk); s2=c*20*sin(wl); c2=20*cos(wl);
      ws=s1/2.0; ws+=!ws; wc=c1/2.0;

      hide();
      if( wx[nk]>-1 )
      {
         color(1); x+=w/2; line( x,y+h,x,y+5 ); line( x+1,y+h,x+1,y+5 );
         xy[0]=xy[2]=x+1; xy[1]=y+5; xy[3]=y+11;
         if( wk<.2 ) { xy[0]=x-1; xy[1]=xy[3]=y+5; xy[2]=x+2; }
         xy[4]=xy[2]+s1; xy[5]=xy[3]+c1;
         xy[8]=xy[0]+s1; xy[9]=xy[1]+c1;
         xy[10]=xy[0];   xy[11]=xy[1];
         xy[6]=((xy[4]+xy[8])>>1)+s2; xy[7]=((xy[5]+xy[9])>>1)+c2;
         v_pline( handle,6,xy );
      }
      fahne();
      show();
   }
   else
   {
      hide();
      clr( a[0],a[1],a[2],a[3] );
      show();
   }
}

/******************* Darstellung der beiden Windfahnen ***********************/
static void fahne(void)
{
   short m=-1;

   while( ++m<2 ) if( wx[m]>-1 )
   {
      clr( wx[m]-10,wy[m]-15,20,15 );
      color(1);
      line( wx[m],wy[m],wx[m],wy[m]-15 );
      if( m==nk )
      {
         line( wx[m],wy[m]-15,wx[m]+ws,wy[m]-13+wc );
         line( wx[m],wy[m]-11,wx[m]+ws,wy[m]-13+wc );
      }
   }
}

/********************** BALLER.TAB laden/speichern ***************************/
static int t_load(void)
{
   if( (f_h=Fopen( "BALLER.TAB",0 ))<0 ) return 1;
   Fread(f_h,1,&an_erl); Fread(f_h,1,&au_kap); Fread(f_h,1,&mxin);
   Fread(f_h,3,**(char ***)(a_opt+MAX_XX*24+12) ); Fread(f_h,2,&max_rund);
   Fread(f_h,48,t_na); Fread(f_h,120,t_gew);
   Fclose(f_h); return 0;
}

static int t_save(void)
{
   if( (f_h=Fcreate( "BALLER.TAB",0 ))<0 ) return 1;
   Fwrite(f_h,1,&an_erl); Fwrite(f_h,1,&au_kap); Fwrite(f_h,1,&mxin);
   Fwrite(f_h,3,**(char ***)(a_opt+MAX_XX*24+12) ); Fwrite(f_h,2,&max_rund);
   Fwrite(f_h,48,t_na); Fwrite(f_h,120,t_gew);
   Fclose(f_h); return 0;
}

/************************* BALLER.DAT laden **********************************/
static void burgen_laden(void)
{
   short *a,j;

   a=(short *)bur_ad;
   if( (f_h=Fopen( "BALLER.DAT",0 ))<0 )
      exit( form_alert(1,DLG_DAT) );
   b_anz=0;
   while( (j=rdzahl())!=-999 )
   {
      burgen[b_anz++]=a;
      *a++=j;
      for( j=0;j<40;j++ ) *a++=rdzahl();
      while( (*a++=rdzahl())!=-1 );
   }
   Fclose( f_h );
}

/* liest ein char von der Datei */
static char zeichen(void)
{
   char a;
   Fread( f_h,1,&a );
   return a;
}

/* liest eine Dezimalzahl von der Datei, Remarks werden berlesen */
static int rdzahl(void)
{
   char a; /* wird durch * getoggled, und zeigt damit an, */
           /* ob man sich in einer Bemerkung befindet */
   int val=0,sign=1,rem=0;

   do
      if( (a=zeichen())=='*' ) rem=!rem;
   while( (a!='-' && a<'0') || a>'9' || rem );

   if( a=='-' ) { sign=-1; a=zeichen(); }
   while( a>='0' && a<='9' )
   {
      val*=10; val+=a-'0';
      a=zeichen();
   }
   return ( sign*val );
}

/************* Kanonenobjektbaum, Wahl von Winkel und Pulver *****************/
static int sch_obj(short k)
{
   static short fig[]={ 0,0,15,20,30,20,20,15,10,0,10,-30,18,-18,20,-5,24,-6,
     20,-25,10,-40,0,-45, -10,-40,-20,-25,-24,-6,-20,-5,-18,-18,-10,-30,-10,0,
     -20,15,-30,20,-15,20, -1,-1 }; /* Daten fr das Mnnchen */
   short i, wi,pv, xw,yw,xp,yp,xk,yk;
   double s,c;
   char *aw,*ap;
   short fl=1;

   aw=*(char **)(a_sch+24*WINK+12);
   ap=*(char **)(a_sch+24*PULV+12);  *(ap+2)=0;

   sav_scr();

   form_center( (obj_t)a_sch,&fx,&fy,&fw,&fh );
   objc_offset( (obj_t)a_sch,WINK,&xw,&yw );
   objc_offset( (obj_t)a_sch,PULV,&xp,&yp );
   objc_offset( (obj_t)a_sch,KAST,&xk,&yk );  xk+=105+fg*36; yk+=102;
   form_dial(1, ka[nk][k].x+10*fg,ka[nk][k].y-10,20,14,fx,fy,fw,fh );
   wi=ka[nk][k].w; pv=ka[nk][k].p;

   vsf_interior( handle,1 );

   i=0; /* make compiler happy */
   do
   {
      if( pv>pu[nk] ) pv=pu[nk];
      *aw=48+wi/100; *(aw+1)=48+wi%100/10; *(aw+2)=48+wi%10;
      if(wi<100) { *aw=*(aw+1); *(aw+1)=*(aw+2); *(aw+2)=0; }
      *ap=48+pv/10; *(ap+1)=48+pv%10;
      if(pv<10)  { *ap=*(ap+1); *(ap+1)=0; }

      if( fl )
      {
         objc_draw( (obj_t)a_sch,0,4,fx,fy,fw,fh );
         hide();
         color(1);
         v_circle( handle,xk-88*fg,yk-60,15 );
         i=0;
         while( fig[i]!=-1 )
            { xy[i]=xk-88*fg+fig[i]; i++; xy[i]=yk-5+fig[i]; i++; }
         xy[i++]=xy[0]; xy[i++]=xy[1];
         v_fillarea( handle,i/2-1,xy );
         show();
      }
      objc_draw( (obj_t)a_sch,0,4,xw,yw,42,18 );
      objc_draw( (obj_t)a_sch,0,4,xp,yp,42,18 );

      if( (i!=PL2 && i!=PR2 && i!=PL1 && i!=PR1) || fl )
      {
         hide();
         clr( xk-55,yk-76,110,90 );
         color( 1 );
         v_circle( handle,xk,yk,15 );

         s=sin(wi/P57); c=cos(wi/P57);
         fl=-fg; if( wi>90 ) { fl=-fl; c=-c; }
         xy[0]=xk+fl*(c*14+s*14);  xy[1]=yk+s*14-c*14;
         xy[2]=xk+fl*(c*14+s*40);  xy[3]=yk+s*14-c*40;
         xy[4]=xk-fl*(c*55-s*40);  xy[5]=yk-s*55-c*40;
         xy[6]=xk-fl*(c*55-s*14);  xy[7]=yk-s*55-c*14;
         xy[8]=xy[0]; xy[9]=xy[1];
         v_fillarea( handle,4,xy );
         show();
         fl=0;
      }

      i=form_do( (obj_t)a_sch,0 ); if( i>=0 ) *(short *)(a_sch+24*i+10)=0;
      wi-=10*(i==WL2)-10*(i==WR2)+(i==WL1)-(i==WR1);
      if( wi<0 ) wi=0;  if( wi>180 ) wi=180;
      pv-= 3*(i==PL2)- 3*(i==PR2)+(i==PL1)-(i==PR1);
      if( pv<5 ) pv=5;  if( pv>20 ) pv=20;
   } while( i!=SOK && i!=SAB );

   lod_scr();

   form_dial(2, ka[nk][k].x+10*fg,ka[nk][k].y-10,20,14,fx,fy,fw,fh );
   ka[nk][k].w=wi; ka[nk][k].p=pv;
   return ( i==SOK );
}
/********************* Neues Spiel: Auswahl der Burgen ***********************/
static int bur_obj(void)
{
   short i,ob0,ob1,oy0,oy1, ol[8];
   short x,y,w,h;

   oy0=by[0]; oy1=by[1]; ob0=bur[0]; ob1=bur[1];

   *(char **)(a_brg+24*BSP1+12)=l_nam;
   *(char **)(a_brg+24*BSP2+12)=r_nam;

   form_center( (obj_t)a_brg,&fx,&fy,&fw,&fh );

   w=*(short *)(a_brg+24*BK1+20);     h=*(short *)(a_brg+24*BK1+22);
   objc_offset( (obj_t)a_brg,BK1,&x,&y ); bx[0]=x;   by[0]=y+h;
   objc_offset( (obj_t)a_brg,BK2,&x,&y ); bx[1]=x+w; by[1]=y+h;

   sav_scr();
   form_dial( 1,70,20,30,20,fx,fy,fw,fh );
   objc_draw( (obj_t)a_brg,0,5,fx,fy,fw,fh );
   ol[0]=ge[0]; ol[1]=ge[1];   ol[2]=pu[0]; ol[3]=pu[1]; /* Sichern der alten*/
   ol[4]=ku[0]; ol[5]=ku[1];   ol[6]=vo[0]; ol[7]=vo[1]; /* Werte */
   burg(2); burg(3);

   do
   {
      ge[0]=ge[1]=pu[0]=pu[1]=ku[0]=ku[1]=9999;
      i=form_do( (obj_t)a_brg,0 ); *(short *)(a_brg+24*i+10)=0;
      if( i==BL1 || i==BR1 )
      {
         bur[0]=(bur[0]+1-2*(i==BL1)+b_anz)%b_anz;
         clr( bx[0],y,w,h ); burg(2);
      }
      if( i==BL2 || i==BR2 )
      {
         bur[1]=(bur[1]+1-2*(i==BL2)+b_anz)%b_anz;
         clr( bx[1]-w,y,w,h ); burg(3);
      }
   } while( i!=BOK && i!=BAB );
   ge[0]=ol[0]; ge[1]=ol[1];  pu[0]=ol[2]; pu[1]=ol[3];
   ku[0]=ol[4]; ku[1]=ol[5];  vo[0]=ol[6]; vo[1]=ol[7];

   lod_scr();
   form_dial( 2,70,20,30,20,fx,fy,fw,fh );

   fn(); by[0]=oy0; by[1]=oy1;
   if( i==BAB ) { bur[0]=ob0; bur[1]=ob1; }
   return ( i==BOK );
}

/************** Darstellung und Verwaltung eines Objektbaumes ****************/
static int obj_do(unsigned long adr)
{
   int a; short x=20,fl=0;
   if(adr==a_nam) { fl=NSP1; x=80; }
   if(adr==a_opt) { fl=MAX_XX; x=80; }
   if(adr==a_com) x=150;
   if(adr==a_ein) { fl=EI_N1; x=260; }

   form_center( (obj_t)adr,&fx,&fy,&fw,&fh );
   sav_scr(); form_dial( 1,x,20,30,20,fx,fy,fw,fh );
   objc_draw( (obj_t)adr,0,5,fx,fy,fw,fh ); a=form_do( (obj_t)adr,fl );
   *(short *)(adr+24*a+10)=0;
   lod_scr(); form_dial( 2,x,20,30,20,fx,fy,fw,fh );
   return a;
}
/*********************** Elementare  Grafikbefehle ***************************/

/* ffnen der Workstation... */
static void gem_init(void)
{
   short i, work_in[11], work_out[57];
   short mtos, dummy;

   appl_init();
#ifdef __AHCC__
   mtos = (_GemParBlk.global[1] == -1);
#else
   mtos = (aes_global[1] == -1);
#endif

   handle=graf_handle( &i, &i, &i, &i );
   for( i=0; i<10; i++ )  work_in[i]=1;
   work_in[10]=2;
   v_opnvwk( work_in, &handle, work_out );

   /* get screen information from VDI */
   wd = work_out[0] + 1;
   ht = work_out[1] + 1;
   if( wd < 640 || ht < 400 )
   {
      form_alert(1,DLG_REZ);
      v_clsvwk( handle ); appl_exit();
      exit(1);
   }
   /* ...and desktop menubar height */
   wind_get(0, WF_WORKXYWH, &dummy, &menuh, &dummy, &dummy);

   /* screen_colors = work_out[13]; */
   vq_extnd( handle, 1, work_out );
   planes = work_out[4];
   wd = wd*planes/8;	/* in bytes */

   form_dial(FMD_START, 320, 200, 0, 0, 0, 0, 640, 400);
   if (mtos)
   {
      /* create window, otherwise cannot get all events */
      win_handle = wind_create(0, menuh, 0, 640, 400-menuh);
      if (win_handle > 0)
         wind_open(win_handle, 0, menuh, 640, 400-menuh);
   }
   /* wind_update(BEG_UPDATE); */

   v_clrwk( handle );
}

static void gem_exit(void)
{
   /* wind_update(END_UPDATE); */

   if (win_handle > 0)
   {
      wind_close (win_handle);
      wind_delete (win_handle);
   }
   form_dial(FMD_FINISH, 320, 200, 0, 0, 0, 0, 640, 400);
   v_clsvwk( handle );
   appl_exit();
}

short color(short a)
{
   static short old = 1;
   vst_color( handle,a );
   vsl_color( handle,a );
   vsf_color( handle,a );
   return old;
}

/* Ermittelt, ob Punkt gesetzt ist */
int loc(short x, short y)
{
   short a,b;
   v_get_pixel(handle,x,y,&a,&b);
   return a;
}

/* Zeichnet eine Linie */
void line(short x1, short y1, short x2, short y2)
{
   xy[0]=x1; xy[1]=y1; xy[2]=x2; xy[3]=y2;
   v_pline( handle, 2, xy );
}

static void box(short x, short y,short x2, short y2)
{
   xy[0]=x; xy[1]=y; xy[2]=x2; xy[3]=y2;
   v_bar( handle,xy );
}

void clr(short x, short y, short w, short h)
{
   short old = color(0);
   box(x,y,x+w-1,y+h-1);
   color(old);
}

/* Lscht den gesamten Bildschirm auer der Menleiste */
void cls(void)
{
   clr(0, menuh, wd*8/planes, ht-menuh);
}
