/*****************************************************************************
 *                         B a l l e r b u r g               Modul 2         *
 * Dies ist der zweite Teil des Ballerburg Sourcecode. Hier werden die       *
 * Computer gesteuert und der Flug der Kugel dargestellt. Auerdem sind      *
 * alle Routinen in Zusammenhang mit dem Markt sowie dem Knig beinhaltet.   *
 *                                 29. 4. 87      Eckhard Kruse              *
 *                                                Reichenbergweg 7           *
 *                                                D-3302 Weddel              *
 * berarbeitet: 20.10.89                                                    *
 *****************************************************************************/
#include "baller.h"
#include "resource.h"
#define BALLER2 1
#include "texts.h"

/***************** Grafikdaten fr Trohn, Kanone... **************************/
static short trohn[]={ -2,2,2, 8,3,5,12,8,12,12,16,12,17,14,15,
   15,15,17,17,17,16,21,11,24,11,21,3,-9, -4, 3,0,5,2,24,2,26,0,-9,
   19,4,18,9,-9, 10,4,11,9,-9, 14,4,15,4,-9, 8,10,11,11,-9, 21,10,18,11,-9,
   14,17,15,17,-9, 13,19,13,19,-9, 16,19,16,19,-9, 12,22,12,21,15,21,14,22,
   17,21,17,22,-9, 6,13,6,17,5,16,5,17,7,17,7,16,-9, -1 },
      kanon[]={ -2,1,1, 1,0,3,3,5,0,3,3,3,11,2,11,2,9,4,9,4,11,3,11,3,8,0,5,
   3,8,6,5,3,8,3,3,-9, 11,0,13,2,15,0,16,0,17,1,17,2,15,4,19,8,16,11,8,3,-9,
   -1 },
      sack[]={ -4, 1,1,1,4,2,5,2,0,3,0,3,8,2,8,4,8,3,8,3,6,4,6,4,0,5,0,
   5,6,6,5,6,1,-9, -1 },
      fass[]={ -4, 2,0,6,0,8,3,8,5,6,8,2,8,0,5,0,3,2,0,3,0,3,3,2,4,3,5,3,8,
   5,8,5,5,6,4,5,3,5,1,-9, -1 },
      kuge[]={ -2,1,1, 1,0,0,1,0,3,1,4,3,4,4,3,4,1,3,0,-9,-1 },
      turm[]={ -4, 23,30,27,0,3,10,24,20,6,30,23,30,5,20,26,10,2,0,6,30,-9,
   8,0,8,31,9,34,11,36,14,37,15,37,18,36,20,34,21,31,21,29,20,26,18,24,15,23,
   14,23,11,24,9,26,8,29,-9, 14,23,15,37,-9, 10,25,19,35,-9, 10,35,19,25,-9,
   21,30,21,0,-9, -1 };
/************************ Der Computer agiert: *******************************/
static int zx,zy;  /* Koordinaten des Zieles */
static short *bh;

/* local function prototypes */
static void z_kn(void);
static void z_ka(void);
static void z_ft(void);
static void z_ge(void);
static void z_pk(void);
static void expls(short x, short y, short w, short h, short d);
static int kugel(short x, short y);
static void baller(signed char r);
static void init_ka(short k, short xr);
static void drw_all(void);
static void draw(short x, short y, short *a);
static void zahl(short nr, short wert);
static void fturm(void);
static void anbau(void);

/* Fhrt einen Zug des Computers durch */
int comp(void)
{
   int i,t;
   signed char wd;
   register double x2=0,x,y,vx2,vx,vy=0,wi;

   st[nk]=16;
   for( i=0;i<10;i++ ) if( ka[nk][i].x>-1 ) break;
   if( pu[nk]<20 && ge[nk]>=p[4] ) { pu[nk]+=30; ge[nk]-=p[4]; }  /* Pulv. kaufen*/
   if( !ku[nk] && ge[nk]>=p[5] )   { ku[nk]+=2;  ge[nk]-=p[5]; }  /* Kug.  kaufen*/
   if( i>9 && ge[nk]>=p[2] ) { init_ka(i=0,639*nk); ge[nk]-=p[2]; } /* Ka. kauf.*/
   if( (ft[nk][0].x<0 || ft[nk][1].x<0 || ft[nk][2].x<0 ) && ge[nk]>=p[1] &&
       cw[nk]>2 )
      { ge[nk]-=p[1]; fturm(); } /* Frderturm kaufen */
   drw_all();

   if( i>9 || pu[nk]<20 || !ku[nk] ) return -1;

        /* Jetzt kommen die Berechnungen fr den Schuss: */
   bh=burgen[bur[!nk]];
   do i=Random()%10; while( ka[nk][i].x==-1 );

   zx=639*!nk-fg*(Random()%bh[0]); zy=by[!nk];
   t=Random()%100;
   if( cw[nk] ) z_kn();
   switch( cw[nk] )  /* Die verschiedenen Strategien */
   {
      case 1: if( t<30 ) z_ge(); if( t>60 ) z_pk(); break;
      case 2: z_ka(); if( t<90 ) z_ge(); break;
      case 3: if( t<50 )z_ka(); else if( t<70 )z_ge(); else if( t<90 )z_pk();
              if( !(Random()%3) ) z_ft();
              break;
      case 4: z_ka(); break;
      case 5: z_ka(); if( t<90 ) z_ft();
   }

   y=ka[nk][i].y-10-zy;    t=49-cx[nk]*16;   /* Berechnen der Distanz */
   x=ka[nk][i].x+9+8*fg-zx -t/2+Random()%t; if( x<0 ) x=-x;

   wd=nk? -wnd:wnd;

   x2=-1;
   for( vx=.5; vx<7 && ( x2<x || vy/3.5>vx ); )  /* Zeitberechnung bei */
   {                              /* verschiedenen X-Geschwindigkeiten */
      vx+=.4;
      t=x2=0; vx2=vx;
      while( vx2>0 && x2<x )
         { x2+=vx2; vx2+=(wd/2-vx2)/5000; t++; }
      vy=y/t+.5*G*t;
   }

   if( nk ) vx=-vx;
   vvx=vx; vvy=vy;  /* Werte fr Schuss bergeben */

   if( vx<0 ) vx=-vx; 
   wi=atan2(vy,vx);
   ka[nk][i].w=wi*P57;
   ka[nk][i].p=(short)(4.0*vx/cos(wi)-1.6);

   return i;
}

/********************* Routinen zur Zielerkennung: ***************************/
/* Die Routinen berechnen die Zielkoordinaten fr den Knig, Kanonen, Geld...*/
static void z_kn(void)
{
   zx=!nk*639-fg*(bh[21]+15);
   zy=by[!nk]-bh[22]-5;
}
static void z_ka(void)
{
   short i;

   for( i=0;i<10;i++ ) if( ka[!nk][i].x>-1 ) break;
   if( i<10 )
   {
      do i=Random()%10; while( ka[!nk][i].x==-1 );
      zx=ka[!nk][i].x+10; zy=ka[!nk][i].y;
   }
}

static void z_ft(void)
{
   short i;

   for( i=0;i<5;i++ ) if( ft[!nk][i].x>-1 ) break;
   if( i<5 )
      { zx=ft[!nk][i].x-15*fg; zy=ft[!nk][i].y-10; }
}

static void z_ge(void)
{
   if( ge[!nk]>100 )
      { zx=!nk*639-fg*(bh[25]+bh[31]/2); zy=by[!nk]-bh[26]; }
}

static void z_pk(void)
{
   short i;

   if( ku[!nk] || pu[!nk]>19 )
   {
      i=Random()&2;
      zx=!nk*639-fg*(bh[27+i]+bh[33+i]/2); zy=by[!nk]-bh[28+i];
   }
}

/********************************* Ein Schuss ********************************/
/* k = Nr. der Kanone */
void schuss(short k)
{
   double x,y,ox,oy,vx,vy;
   short v,c,a,j,oldn;

   hide();
   pu[nk]-=ka[nk][k].p; ku[nk]--;
   drw_gpk(1); drw_gpk(2);

   x=ka[nk][k].x+9+8*fg; y=ka[nk][k].y-10; c=2;
   vx=(.4+0.25*ka[nk][k].p)*cos( ka[nk][k].w/P57 )*fg;
   vy=(.4+0.25*ka[nk][k].p)*sin( ka[nk][k].w/P57 );

   if( mod&(2-nk) ) { vx=vvx; vy=vvy; }

   color(1); vswr_mode( handle,3 );

   baller(0);

   kugel( (short)x,(short)y ); v=1;
   ox=x; oy=y;
   while( x>3 && x<637 && y<396 &&  ( v || c ) )  /* Flugschleife */
   {
      ox=x; oy=y; x+=vx; y-=vy;
      vy-=G; vx+=(wnd/2-vx)/5000;
      kugel( (short)ox,(short)oy );
      if( kugel( (short)x,(short)y ) )
         v=loc((short)x,(short)y)& loc((short)x-1,(short)y+1)& loc((short)x+1,(short)y+2);
      a=1000+2*y; if( a<30 ) a=30;
      (void)Giaccess( 10,137 );    (void)Giaccess( 244,135 );
      (void)Giaccess( a&255,130 ); (void)Giaccess( a>>8,131 );
      if( c ) c--;
   }
   kugel( (short)x,(short)y );
   vswr_mode( handle,1 ); color( 0 );
   oldn=nk;
   if( !v ) for( c=0;c<4;c++ )      /* Einschlag der Kugel */
   {
      if( ox>6 && ox<634 ) v_circle( handle, (short)ox,(short)oy, 5 );

      baller(22+c*3);

      for( nk=0;nk<2;nk++ )    /* Treffer ? */
      {
         bg=burgen[bur[nk]];
         if( Random()&1 && (nk? x>639-bg[0] : x<bg[0]) && vo[nk] ) vo[nk]--;
         fn();
         for( j=0;j<10;j++ )
            if( ka[nk][j].x<ox+2 && ka[nk][j].x+22>ox && ka[nk][j].x>-1 &&
                ka[nk][j].y-16<oy && ka[nk][j].y>oy )
            {
	       a=ka[nk][j].x;
	       v=ka[nk][j].y-12;
               clr( a,v,20,13 );
               expls( a+10,v+6,13,8,50 ); color(0);
               ka[nk][j].x=-1;
            }
         for( j=0;j<5;j++ )
         {
            a=639*nk+fg*ft[nk][j].x;
            v=by[nk]-ft[nk][j].y;
            if( ft[nk][j].x>-1 && drin( a,v,30,37,2,(short)ox,(short)oy ) )
            {
               if( drin( a,v,30,37,-2,(short)ox,(short)oy ) )
               {
		  a=ft[nk][j].x-29*nk;
		  v=ft[nk][j].y-40;
                  expls(a+15,v+20,15,20,120);
                  clr( a,v,30,40 ); ft[nk][j].x=-1;
               }
               c=4;
            }
         }
         if( ox>wx[nk]-11 && ox<wx[nk]+11 && oy>wy[nk]-16 && oy<wy[nk] && wx[nk]>-1)
            { clr( wx[nk]-10,wy[nk]-15,20,15 ); wx[nk]=-1; }
         if( drin( bg[21],bg[22],30,25,0,(short)ox,(short)oy ) )
         {
            ended=nk+17;
	    a=639*nk+fg*(bg[21]+15);
	    v=by[nk]-bg[22]-12;
            expls( a,v,17,17,40 );
            v_circle( handle, a,v,17 );
            expls( a,v,17,17,200 ); c=4;
         }
         for( j=0;j<6;j+=2 )
	 {
            a=bg[31+j]; v=bg[32+j];
            if( drin( bg[25+j],bg[26+j],a,v,3, (short)ox,(short)oy ) ) break;
         }
         switch( j )
         {
            case 0: ge[nk]-=Min(200,ge[nk]); break;
            case 2: pu[nk]=0; break;
            case 4: ku[nk]-=Min(2,ku[nk]);
         }
         if( j<6 )
         {
            expls( 639*nk+fg*(bg[25+j]+a/2),by[nk]-bg[26+j]-v/2,
                   a/2,v/2,60+100*(j==2) );
            drw_gpk(j/2); c=4;
         }
      }
      ox+=vx; oy-=vy;
   }
   nk=oldn; fn();
   (void)Giaccess( 0,137 );
   show();
}

/****************************** Explosion ************************************/
static void expls(short x, short y, short w, short h, short d)
{
   short i,j;

   vswr_mode( handle,3 );
   for( i=0;i<32; ) { xy[i++]=x; xy[i++]=y; }
   while( d-->0 )
   {
      v_pline( handle,2,xy );
      movmem( xy+4,xy,120 );
      for( j=28;j<32; )
        { xy[j++]=x-w+w*(Random()&511)/256; xy[j++]=y-h+h*(Random()&511)/256; }
      v_pline( handle,2,xy+28 );
      baller( (d&31)^31 );
   }
   for( i=0;i<32;i+=4 ) v_pline( handle,2,xy+i );
   vswr_mode( handle,1 );
}

static int kugel(short x, short y)
{
   if( x<3 || x>637 || y<23 ) return 0;
   line( x-2,y-2,x+1,y-2 );
   line( x-3,y-1,x+2,y-1 );
   line( x-3,y  ,x+2,y   );
   line( x-3,y+1,x+2,y+1 );
   line( x-2,y+2,x+1,y+2 );
   return 1;
}

static void baller(signed char r)
{
   static signed char s_bal[]=
	{ 0,0,1,15,6,31,9,0,11,0,12,50,13,0,7,192,8,16,255,0 };

   s_bal[5]=r;
   Dosound( s_bal );
}

/**************************** Neues Bild zeichnen ****************************/
void bild(void)
{
   short y,x1,x2,v1,v2;

   hide();
   cls();

   by[0]=(Random()%80+300)&~3; by[1]=(Random()%80+300)&~3;

   y=400; x1=0; x2=2556; color( 1 ); v1=v2=2;
   vsl_type( handle,7 );
   while( x1<x2 && --y>20 )
   {
      vsl_udsty( handle,~((257<<(Random()&7))*(y&1)) );
      line( x1/4,y,x2/4,y );
      if( y==by[0] ) x1=*burgen[bur[0]]*4;
      if( y==by[1] ) x2=(639-*burgen[bur[1]])<<2;
      if( x1 )
         { v1=v1+Random()%5-2; v1=Max(0,v1); v1=Min(7,v1); x1+=v1; }
      if( x2<2556 )
         { v2=v2+Random()%5-2; v2=Max(0,v2); v2=Min(7,v2); x2-=v2; }
   }
   vsl_type( handle,1 );
   setmem( ka,160,-1 );
   burg(0); burg(1);
   v_gtext(handle,276,395,TXT_RUNDE);
   show();
}

/***************************** Burg zeichnen *********************************/
void burg(short nn)
{
   short i,xr,oldn;

   oldn=nk; nk=nn; fn();
   xr=nk&2? bx[nk&=1]:639*nk;
   bg=burgen[bur[nk]];
   ge[nk]=bg[37]; pu[nk]=bg[38]; ku[nk]=bg[39]; vo[nk]=bg[40];

   color(1);
   vswr_mode( handle,4 ); draw( xr, by[nk], &bg[45] );
   vswr_mode( handle,1 );
   clr( xr+fg*bg[21]-nk*30,by[nk]-bg[22]-25,30,25 );
   color(1); draw( xr+fg*bg[21], by[nk]-bg[22], trohn );

   nk=nn;
   for( i=0; i<10 && bg[i*2+1]>-1; i++ ) init_ka( i,xr );
   drw_all();
   nk=oldn;
}

/* Kanone k setzen */
static void init_ka(short k, short xr)
{
   short x,y;

   draw( x=xr+bg[1+k*2]*fg, y=by[nk&1]-bg[2+k*2], kanon );
   if( ~nk&2 )
     { ka[nk][k].x=x-20*nk; ka[nk][k].y=y; ka[nk][k].w=45; ka[nk][k].p=12; }
}

/* Geld, Pulver und Kugeln zeichnen */
static void drw_all(void)
{
   drw_gpk(0); drw_gpk(1); drw_gpk(2);
}

void drw_gpk(short w)
{
   short i,z, x,y, xr,yr, *a,xp,yp, m=nk&1;

   switch( w )
   {
      case 0: a=sack;  xp=7; yp=10;  i=(ge[m]+149)/150; break;
      case 1: a=fass;  xp=yp=9;      i=(pu[m]+29)/30;  break;
      case 2: a=kuge;  xp=yp=6;      i=ku[m];
      default:
	 /* make compiler happy, this shouldn't happen */
         return;
   }
   bg=burgen[bur[m]]; w*=2;
   xr=(nk&2? bx[m]:639*m)+fg*bg[25+w]; yr=by[m]-bg[26+w];

   hide();
   clr( xr-bg[31+w]*m-!nk,yr-bg[32+w],bg[31+w]+1,bg[32+w]+1 );
   color(1);

   for( y=z=0; i>0 && y<bg[32+w]; y+=yp )
      for( x=0; i>0 && x<bg[31+w]; x+=xp,z++,i-- )
         draw( xr+fg*x, yr-y, a );
   show();
   if( i>0 )    /* Maximalbetrag berschritten ? */
      switch( w )
      {
         case 0: ge[m]=z*150; break;
         case 2: pu[m]=z*30;  break;
         case 4: ku[m]=z;
      }
}

/***************************** Zeichenroutine ********************************/
static void draw(short x, short y, short *a)
{
   short i,fil=1;

   hide();
   vsf_interior( handle,2 ); vsf_style( handle,9 );
   while(*a != -1)
   {
      if(*a == -2)
         { vsf_interior( handle,*++a ); vsf_style( handle,*++a ); }
      else if(*a == -4) fil=!fil;
      else
      {
         i=0;
         while(*a > -1)
            { xy[i++]=x+*a++*fg; xy[i++]=y-*a++; }
         xy[i++]=xy[0]; xy[i++]=xy[1];
         if( fil ) v_fillarea( handle,i/2,xy );
         else v_pline( handle,i/2-1,xy );
      }
      a++;
   }
   show();
}

/******************************** Markt **************************************/
void markt(void)
{
   short a,k,ko,t;

   form_center( (obj_t)a_sta,&fx,&fy,&fw,&fh );
   sav_scr();
   form_dial( 1,mx,my,30,20,fx,fy,fw,fh );

   for( a=0;a<6;a++ ) zahl( SM1+a, p[a] );
   do
   {
      for( t=k=0;k<5; ) t+=(ft[nk][k++].x>-1);
      for( ko=k=0;k<10; ) ko+=(ka[nk][k++].x>-1);
      for( k=0;k<10;k++ )
         if( bg[1+k*2]>-1 && ka[nk][k].x==-1 )
         {
            hide(); for( a=1;a<10;a++ )
               if( loc(639*nk+(bg[1+k*2]+5+a)*fg,by[nk]-bg[2+k*2]-a) ) break;
            show(); if( a>9 ) break;
         }
      zahl( SH1,ge[nk] ); zahl( SH2,t );
      zahl( SH3,ko    ); zahl( SH4,wx[nk]>-1 );
      zahl( SH5,pu[nk] ); zahl( SH6,ku[nk] );
      zahl( SH7,vo[nk] ); zahl( SH8,st[nk] ); 
      for( a=0;a<6;a++ )
         *(short *)(a_sta+24*(SM1+a)+10)=8* ( ge[nk]<p[a] ||
	   (!an_erl && !a) || (a==1 && (bg[0]+t*30>265||t>4)) ||
	   (a==2 && k>9) || (a==3 && wx[nk]>-1) );

      objc_draw( (obj_t)a_sta,0,5,fx,fy,fw,fh );

      a=form_do( (obj_t)a_sta,0 ); if( a>=0 ) *(short *)(a_sta+24*a+10)=0;
      if( a==SHK ) st[nk]-=2*(st[nk]>0);
      else if( a==SHG ) st[nk]+=2*(st[nk]<100);
      else if( a!=FERTIG && a-SM1>-1 && a-SM1<6)
      {
         ge[nk]-=p[a-SM1];
         if( a<SM5 )
         {
            lod_scr(); drw_all();
            if( a==SM1 ) anbau();
            else if( a==SM2 ) fturm();
            else if( a==SM3 ) init_ka( k,639*nk );
            else if( a==SM4 )
               { wx[nk]=639*nk+fg*bg[23]; wy[nk]=by[nk]-bg[24]; werdran(1); }
            sav_scr();
         }
         else
           {pu[nk]+=30*(a==SM5); ku[nk]+=2*(a==SM6); drw_gpk(a-SM4); drw_gpk(0);}
      }
   } while( a!=FERTIG );

   lod_scr(); drw_all();
   form_dial( 2,mx,my,30,20,fx,fy,fw,fh );
}

/* 5-stellige Zahl, rechtsbndig, ohne fhrende Nullen */
static void zahl(short nr, short wert)
{
   short i,a,b;
   char *adr;

   adr=*(char **)(a_sta+24*nr+12)+11;
   for( b=i=0,a=10000; i<5; i++,a/=10 )
     { *adr++=48+wert/a-16*(wert<a && i<4 && !b); b|=wert/a; wert%=a; }
}

/********************* Von Markt aufzurufende Routinen ***********************/
/* Frderturm bauen */
static void fturm(void)
{
   short x,y,yy,i,t;

   hide();
   for( t=0;t<5;t++ ) if( ft[nk][t].x==-1 ) break;
   x=639*nk+fg*(bg[0]+20+30*t); y=380;
   do
   {
      while( loc(x,y) && loc(x+29*fg,y--) );
      yy=y;
      for( i=0;i<40;i++,y-- ) if( loc(x,y) && loc(x+29*fg,y) ) break;
   } while( i<40 );
   y=yy;
   clr( x-29*nk,y-70,30,70 );
   color( 1 ); draw( ft[nk][t].x=x,ft[nk][t].y=y,turm );
   show();
}

/* Anbauen */
static void anbau(void)
{
   short s;
   char a[3];

   color(1); vsf_interior( handle,2 ); vsf_style( handle,9 ); 
   v_gtext( handle,280,375,TXT_ANBAUEN );
   v_gtext( handle,220,395,TXT_STEINE); s=20;
   graf_mouse(6,0);

   do
   {
      maus();
      if( bt && (nk? mx>624-bg[0] : mx<bg[0]+15 ) && my>155 )
      {
         hide();
         if( !( loc(mx,my) || loc(mx+1,my+1) || loc(mx-1,my-1) ) &&
            ( loc(mx+3,my-1)||loc(mx+3,my+1)||loc(mx-3,my-1)||loc(mx-3,my+1)||
              loc(mx+1,my+2)||loc(mx-1,my+2)||loc(mx+1,my-2)||loc(mx-1,my-2) ))
         {
            vswr_mode( handle,4 );
            xy[0]=mx-2; xy[1]=my-1; xy[2]=mx+2; xy[3]=my+1;
            v_bar( handle,xy );
            vswr_mode( handle,1 );
            s--;
            a[0]=48+s/10; a[1]=48+s%10; a[2]=0; v_gtext( handle,396,395,a );
         }
         show();
      }
   } while( s>0 && bt<2 );
   rst_scr(208, 360, 224, 40);
   graf_mouse(0,0);
}

void koenig(void)
{
   int k,t,j,i;
   char a[300],*s[20];
   static char *ltz[2];

   for( j=k=0;j<10;j++ ) k+=ka[nk][j].x>-1;
   for( j=t=0;j<5;j++ )  t+=ft[nk][j].x>-1;

   if( !(Random()%20) || kn[nk]&16 || (kn[nk]&15)>9 )
      form_alert(1,DLG_KEINE_LUST);
   else
   {
      kn8[KN_OFFSET]=kn[nk]>2559? '0'+kn[nk]/2560:' ';
      kn8[KN_OFFSET+1]='0'+kn[nk]%2560/256;

      j=Random(); i=2;
      s[0]=j&1? kn0:kn10; s[1]=j&2? kn12:kn6; if( j&4 ) s[i++]=kn14;

      if( ge[nk]>p[1] && t<3 ) s[i++]=kn5;
      if( (st[nk]>40 && vo[nk]<bg[40]) || st[nk]>70 ) s[i++]=kn3;
      if( wx[nk]<0 ) s[i++]=kn9;
      if( ge[nk]>bg[37] && vo[nk]>bg[40] && k>1 ) s[1]=t<2? kn1:kn2;
      if( t>2 ) s[i++]=kn2;
      if( k<1 && ge[nk]<p[2] ) s[i++]=kn4;
      if( (kn[nk]&15)>4 )
	{ s[i++]=kn7; s[i++]=kn7; s[i++]=kn7; }
      if( (kn[nk]&15)>6 || (!(Random()&7) && kn[nk]>2048) )
	{ s[i++]=kn8; s[i++]=kn8; }
      if( zug<4 ) s[1]=s[2]=s[(i=4)-1]=kn11;
      do
         if( s[j=Random()%i]==ltz[nk] )
	   { s[i++]=kn13; s[i++]=kn13; }
      while( s[j]==ltz[nk] );

      strcpy( a,kna ); strcat( a,ltz[nk]=s[j] ); strcat( a,kne );
      form_alert(1,a);
   }
   kn[nk]|=16; kn[nk]+=256; if( ~kn[nk]&15 ) kn[nk]++;
}

 /* Test, ob Koord. innerhalb eines Rechteckes */
int drin(short xk, short yk, short w, short h, short r, short x, short y)
{
   if( nk ) xk=639-xk-w;
   return( x>xk-r && x<xk+w+r && y<by[nk]-yk+r && y>by[nk]-yk-h-r );
}
