/* This file contains definitions for all the user visible strings
 * in the Ballerburg which are not in the resource file.
 * 
 * They are collected here to help in translating Ballerburg,
 * but they really should also be in the resource file...
 */

#if 0
/* Does TOS path separator work under MiNT with all compilers? */
#include "rscfile.h"	/* RSC file name */
#else
#define RSCFILE "BALLER.RSC"
#endif

/* texts below are used only by baller1.c ***********************************/
#ifdef BALLER1

/* Alert dialogs */
#define DLG_REZ "[1]['Ballerburg' works|only in 640x400 or better|resolutions!][Abort]"
#define DLG_RSC "[1][" RSCFILE "|cannot be loaded!][Abort]"
#define DLG_MEM "[1][Not enough memory!][Abort]"
#define DLG_TAB "[1][Loading BALLER.TAB failed!][Cancel]"
#define DLG_DAT "[1][BALLER.DAT not found!][Abort]"
#define DLG_PULVER "[0][Not enough powder!][Cancel]"
#define DLG_KUGELN "[0][No cannonballs!][Cancel]"

/* other texts */
#define TXT_SPIELE " Games"
#define TXT_GEWONNEN1 " Won"
#define TXT_VERLOREN1 " Lost"
#define TXT_SIEGE " Win in%"
#define TXT_VERLOREN2 " LOST"
#define TXT_GEWONNEN2 " WON"
/* there are some string concatenations in ende() which would need to
   be changed to sprintf()s for Ballerburg to be properly translatable. */
#define TXT_GEWONNEN " has won !!"
#define TXT_GETROFFEN1 "King was hit, and"
#define TXT_GETROFFEN2 "  his people surrendered. )"
#define TXT_KAPITULIERT1 "King's situation was such"
#define TXT_KAPITULIERT2 "  that he couldn't but surrender. )"
#define TXT_KEIN_VOLK " has no people anymore. )"
#define TXT_MAX_RUNDEN1 "( The maximum number of rounds was reached."
#define TXT_MAX_RUNDEN2 " was in the worse state. )" /* prefixed with person */

#endif

/* texts below are used only by baller2.c ***********************************/
#ifdef BALLER2

/* alert dialogs */
#define DLG_KEINE_LUST "[0][The King doesn't feel|inclined to comment.][What a pity]"

/* other texts (need to be same lenght) */
#define TXT_RUNDE   " Round     "	/* max. 6 letters */
#define TXT_ANBAUEN " Building: "
#define TXT_STEINE "    Remaining bricks: 20 "

/*********************** Audience with the King ******************************/
/* TODO: kn8 string handling should be changed to sprintf()s */
static
char kna[]="[0][Thus spoke the King:          |'",
    kne[]="'|][Humbly noted]",
     kn0[]="Hmm...| Well, well...| Just continue...",
     kn1[]="I'm pleased with|your achievements!",
     kn2[]="Brilliant,|please continue!",
     kn3[]="Perhaps you should|cut down the taxes...",
     kn4[]="Continue like this|and you're fired!",
     kn5[]="Another mine shaft|perhaps...",
     kn6[]="Please spend some|more effort yourself!",
     kn7[]="You really need to|bother me on each round?",
     kn8[]="You know,|you've visted|me %d times?",
     kn9[]="You sure you manage|without a wind vane?",
    kn10[]="Nice to see you...",
    kn11[]="What shall I say|in this early phase?",
    kn12[]="Build mine shafts,|earn more money|and defeat your foe.",
    kn13[]="I don't have anything|new to say.",
    kn14[]="How kind of you|to visit me!";

/* offset for the kn8[] char for %d message count */
#define KN_OFFSET 28

#endif /* BALLER2 */
